/**
 * @author diverKon <diverKon@gmail.com>
 * @license http://www.opensource.org/licenses/bsd-license.php
 */
package jp.ne.sakura.kkkon.yamahart;

import java.util.Arrays;
import java.util.List;
import java.util.ArrayList;

/**
 *
 */
public class ConfigList
{
    public static class Config
    {
        public boolean isDefault = false;
        public String No = null;
        public String Date = null;
        public String Time = null;
        public String Size = null;

        public int No_integer = -1;
        public int No_decimal = -1;

		/* (non-Javadoc)
		 * @see java.lang.Object#toString()
		 */
		@Override
		public String toString() {
			return "Config [isDefault=" + isDefault + ", No=" + No + ", Date="
					+ Date + ", Time=" + Time + ", Size=" + Size
					+ ", No_integer=" + No_integer + ", No_decimal="
					+ No_decimal + "]";
		}
    }

    protected Config[] aConfig = null;

    public void parse( final String string )
    {
        if ( null == string )
        {
            throw new IllegalArgumentException();
        }

        final String[] lines = string.split( "\r\n" );
        if ( null == lines )
        {
            return;
        }

        List<Config> listConfig = new ArrayList<Config>();

        final int lines_count = lines.length;
        boolean inList = false;
        for ( int index = 0; index < lines_count; ++index )
        {
            final String line = lines[index];
            if ( null == line )
            {
                continue;
            }

            if ( 0 <= line.indexOf( "----- ---------- " ) )
            {
                inList = !inList;
                continue;
            }

            if ( inList )
            {
                final int line_length = line.length();
                if ( line_length < 41 )
                {
                    continue;
                }

                Config config = new Config();
                if ( 5 <=  line_length )
                {
                    final String field = line.substring( 0, 5 );
                    if ( '*' == field.charAt(0) )
                    {
                        config.isDefault = true;
                    }
                    final String no = field.substring( 2 );
                    config.No = no.trim();

                    final int pos = config.No.indexOf( '.' );
                    if ( 0 <= pos )
                    {
                        final String integer = config.No.substring( 0, pos );
                        final String deciaml = config.No.substring( pos+1 );
                        try
                        {
                            config.No_integer = Integer.parseInt( integer );
                            config.No_decimal = Integer.parseInt( deciaml );
                        }
                        catch ( NumberFormatException e )
                        {
                            e.printStackTrace( System.err );
                        }
                    }
                    else
                    {
                        try
                        {
                            config.No_integer = Integer.parseInt( config.No );
                            config.No_decimal = 0;
                        }
                        catch ( NumberFormatException e )
                        {
                            e.printStackTrace( System.err );
                        }
                    }
                }
                if ( 16 <= line_length )
                {
                    final String field = line.substring( 6, 6+10 );
                    config.Date = field;
                }
                if ( 25 <= line_length )
                {
                    final String field = line.substring( 17, 17+8 );
                    config.Time = field;
                }
                if ( 25 <= line_length )
                {
                    final String field = line.substring( 26, 26+6 );
                    config.Size = field.trim();
                }

                listConfig.add( config );
                System.out.println( config.toString() );
            }
        }

        this.aConfig = new Config[listConfig.size()];
        listConfig.toArray( this.aConfig );

    }

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "ConfigList [aConfig=" + Arrays.toString(aConfig) + "]";
	}
}
