/**
 * @author diverKon <diverKon@gmail.com>
 * @license http://www.opensource.org/licenses/bsd-license.php
 */
package jp.ne.sakura.kkkon.yamahart;

/**
 *
 */
public class LoggerFactory
{

    private static final Logger dummy =
        new Logger()
        {
            public void log( int level, final String msg ) {}

            public void trace( final String msg ) {}
            public void debug( final String msg ) {}
            public void info( final String msg ) {}
            public void warn( final String msg ) {}
            public void error( final String msg ) {}
        };

    private static Logger logger = null;

    public static Logger getLogger( @SuppressWarnings("rawtypes") final Class cls )
    {
        if ( null == logger )
        {
            return dummy;
        }
        return logger;
    }

    public static void setLogger( final Logger _logger )
    {
        logger = _logger;
    }

}
