/**
 * @author diverKon <diverKon@gmail.com>
 * @license http://www.opensource.org/licenses/bsd-license.php
 */
package jp.ne.sakura.kkkon.yamahart;

import java.io.ByteArrayOutputStream;

import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;
import com.jcraft.jsch.SftpException;


/**
 *
 */
public class SFTP
{
    private static final Logger logger = LoggerFactory.getLogger( Telnet.class );


    protected void setOption( final JSch client )
    {
        if ( null == client )
        {
            throw new IllegalArgumentException();
        }

        //client.setKnownHosts( "~/.ssh/known_hosts" );
        JSch.setConfig( "StrictHostKeyChecking", "no" );
    }

    protected Session connect( final JSch client, final Account account )
    {
        if ( null == client || null == account )
        {
            throw new IllegalArgumentException();
        }

        Session session = null;
        try
        {
            session = client.getSession( account.username, account.hostname );
        }
        catch ( JSchException e )
        {
            e.printStackTrace( System.err );
        }

        if ( null != session )
        {
            try
            {
                Thread.sleep( 1*1000 );
            }
            catch ( InterruptedException e )
            {
                e.printStackTrace( System.err );
            }
        }

        return session;
    }

    protected void login( final Session session, final Account account, final ByteArrayOutputStream outStreamResult )
    {
        if ( null != session )
        {
            //session.setPassword( account.passwordLogin );
            session.setPassword( account.passwordAdmin );
            try
            {
                session.connect( 10 * 1000 );
            }
            catch ( JSchException e )
            {
                e.printStackTrace( System.err );
            }
        }
    }


    public void sftpGetConfig(final Account account, final String configNo )
    {
        if ( null == account )
        {
            throw new IllegalArgumentException();
        }

        if ( null == account.hostname )
        {
            throw new IllegalArgumentException();
        }
        if ( 0 == account.hostname.length() )
        {
            throw new IllegalArgumentException();
        }

        JSch client = new JSch();
        this.setOption( client );

        Session session = this.connect( client, account );

        if ( null != session )
        {
            ByteArrayOutputStream outStreamResult = new ByteArrayOutputStream( 8*1024 );

            this.login( session, account, outStreamResult );

            Channel channel = null;
            try
            {
                channel = session.openChannel( "sftp" );
            }
            catch ( JSchException e )
            {
                e.printStackTrace( System.err );
            }

            if ( null != channel && channel instanceof ChannelSftp )
            {
                try
                {
                    channel.connect( 3*1000 );
                }
                catch ( JSchException e )
                {
                    e.printStackTrace( System.err );
                }

                ChannelSftp sftp = (ChannelSftp)channel;
                String filename = "/system/config";
                if ( null != configNo )
                {
                    filename += configNo;
                }

                try
                {
                    sftp.get( filename, outStreamResult );
                }
                catch ( SftpException e )
                {
                    e.printStackTrace( System.err );
                }
                final String str = outStreamResult.toString();
                logger.info( ">>>" );
                logger.info( str );
                logger.info( ">>>" );

            }

            if ( null != channel )
            {
                channel.disconnect();
                channel = null;
            }
        }

        if ( null != session )
        {
            session.disconnect();
            session = null;
        }

        client = null;
    }


}
