/**
 * @author diverKon <diverKon@gmail.com>
 * @license http://www.opensource.org/licenses/bsd-license.php
 */
package jp.ne.sakura.kkkon.yamahart;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.SocketException;
import java.net.UnknownHostException;
import org.apache.commons.net.tftp.TFTP;
import org.apache.commons.net.tftp.TFTPClient;

/**
 *
 */
public class Tftp
{

    public void tftpGetConfig( final Account account, final String configNo )
    {
        if ( null == account )
        {
            throw new IllegalArgumentException();
        }

        if ( null == account.hostname )
        {
            throw new IllegalArgumentException();
        }

        if ( 0 == account.hostname.length() )
        {
            throw new IllegalArgumentException();
        }

        TFTPClient client = new TFTPClient();
        try
        {
            client.setDefaultTimeout( 1*1000 );
            try
            {
                client.open();
            }
            catch ( SocketException e )
            {
                e.printStackTrace( System.err );
            }

            ByteArrayOutputStream outStream = new ByteArrayOutputStream( 16*1024 );

            int result = 0;
            for ( int login_type = 0; login_type < 2; ++login_type )
            {
                outStream.reset();
                String filename = "config";
                if ( null != configNo )
                {
                    filename += configNo;
                }
                switch ( login_type )
                {
                case 0:
                    break;
                case 1:
                    filename += "/" + account.passwordAdmin;
                    break;
                }
                try
                {
                    result = client.receiveFile( filename, TFTP.BINARY_MODE, outStream, account.hostname, TFTP.DEFAULT_PORT );
                }
                catch ( UnknownHostException e )
                {
                    e.printStackTrace( System.err );
                }
                catch ( IOException e )
                {
                    String msg = e.getMessage();
                    if ( null != msg )
                    {
                        msg = msg.toLowerCase();
                        if ( 0 <= msg.indexOf( "access violation" ) )
                        {
                            continue;
                        }
                    }
                    e.printStackTrace( System.err );
                    if ( null != msg )
                    {
                        if ( 0 <= msg.indexOf( "no such file" ) )
                        {
                            break;
                        }
                    }
                }
            }

            try
            {
                outStream.flush();
            }
            catch ( IOException e )
            {
                e.printStackTrace( System.err );
            }

            System.out.println( outStream.toString() );
        }
        finally
        {
            client.close();
            client = null;
        }

    }
}
